/* vim: set sts=4 sw=4 et :
 *
 * A small library that can be loaded using LD_PRELOAD to do malicious things 
 * to test whether apparmor works
 */

#define _GNU_SOURCE
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>

#include <glib.h>

void
do_malicious_stuff (void)
{
    char* filename;
    char* contents;
    GError* error = NULL;

    /* We'll try to load the contents of the user's bash history.
     * Do not use g_get_home_dir() here as it could read from /etc/passwd,
     * which could mean we require more AppArmor rules just for this test. */
    filename = g_strdup_printf ("%s/.bash_history", g_getenv ("HOME"));
    g_file_get_contents (filename, &contents, NULL, &error);

    if (g_error_matches (error, G_FILE_ERROR, G_FILE_ERROR_ACCES)) {
        fprintf (stderr, "Unable to be malicious: %s -- SUCCESS\n", error->message);
    } else {
        fprintf (stderr, "Malicious code read contents of '%s' -- FAILURE\n", filename);
        /* Exit immediately if apparmor doesn't stop us. */
        exit(EXIT_FAILURE);
    }
}
