#!/bin/bash
# vim: set sts=4 sw=4 et tw=0 :

set -e

TESTDIR=$(cd $(dirname $0); pwd; cd - &>/dev/null)
. "${TESTDIR}/config.sh"

#########
# Setup #
#########
trap "setup_failure" ERR

ensure_dbus_session

grep -q interface /etc/dbus-1/system.conf

sudo sed -i \
  's|^.*<interface>org.freedesktop.DBus.Debug.Stats</interface>.*$|<interface>org.freedesktop.DBus.Debug.Stats</interface>|' \
  /etc/dbus-1/system.conf
sudo sed -i \
  's|^  <standard_session_servicedirs />$|  <standard_session_servicedirs /><interface>org.freedesktop.DBus.Debug.Stats</interface>|' \
  /etc/dbus-1/session.conf
grep -q interface /etc/dbus-1/system.conf

sudo pkill -HUP dbus-daemon
sleep 1

sudo sed -i \
  's|^.*<interface>org.freedesktop.DBus.Debug.Stats</interface>.*$|  <!-- <interface>org.freedesktop.DBus.Debug.Stats</interface> -->|' \
  /etc/dbus-1/system.conf
sudo sed -i \
  's|^  <standard_session_servicedirs /><interface>org.freedesktop.DBus.Debug.Stats</interface>$|  <standard_session_servicedirs />|' \
  /etc/dbus-1/session.conf


setup_success

###########
# Execute #
###########
say "Results will be in /tmp/dbus-match-rule-list-*.txt"
test_match_rules_system() {
    "${TESTDIR}/match-rules.py" --system  &> /tmp/dbus-match-rule-list-system.txt
}

test_match_rules_session() {
    "${TESTDIR}/match-rules.py" --session &> /tmp/dbus-match-rule-list-session.txt
}

trap "cat /tmp/dbus-match-rule-list-*.txt ; test_failure" ERR

src_test_pass <<-EOF
test_match_rules_system
test_match_rules_session
EOF

test_success
